<?php
/*
  $Id$ Twitter Typeahead Autocomplete Search v1.8 for oscommerce 2.3.4BS

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2016 osCommerce

  Released under the GNU General Public License
*/

chdir('../../../../');
require('includes/application_top.php');

$return_array = array();

if (isset($_GET['term'])) {

  $search_term = tep_db_prepare_input($_GET['term']);

  if (tep_not_null($search_term)) {
    if (tep_parse_search_string($search_term, $term)) {

      if (isset($term) && (sizeof($term) > 0)) {

        $where_str = " and (";
        for ($i=0, $n=sizeof($term); $i<$n; $i++ ) {
          switch ($term[$i]) {
            case '(':
            case ')':
            case 'and':
            case 'or':
              $where_str .= " " . $term[$i] . " ";
              break;
            default:
              $keyword = tep_db_prepare_input($term[$i]);
              $where_str .= "(";
              if ( (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SEARCH_PRODUCT_META_KEYWORDS == 'true') && (defined('MODULE_HEADER_TAGS_PRODUCT_META_KEYWORDS_STATUS')) && (MODULE_HEADER_TAGS_PRODUCT_META_KEYWORDS_STATUS != 'Meta') ) {
                $where_str .= "pd.products_seo_keywords like '%" . tep_db_input($keyword) . "%' or ";
              }
              $where_str .= "pd.products_name like '%" . tep_db_input($keyword) . "%' or p.products_model like '%" . tep_db_input($keyword) . "%'" . (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_INCLUDE_MANUFACTURER == 'true' ? " or m.manufacturers_name like '%" . tep_db_input($keyword) . "%'" : "") . (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SEARCH_IN_DESCRIPTION == 'true' ? " or pd.products_description like '%" . tep_db_input($keyword) . "%'" : "");
              $where_str .= ")";
              break;
          }
        }
        $where_str .= " )";

        $results_query = tep_db_query("select p.products_id, pd.products_name," . (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SEARCH_IN_DESCRIPTION == 'true' ? " pd.products_description," : "") . " p.products_image, p.products_tax_class_id, p.products_model, s.status, s.specials_new_products_price, p.products_price" . (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_INCLUDE_MANUFACTURER == 'true' ? ", m.manufacturers_name" : "") . " from products p" . (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_INCLUDE_MANUFACTURER == 'true' ? " left join manufacturers m using(manufacturers_id)" : "") . " left join specials s on p.products_id = s.products_id, products_description pd WHERE p.products_status = '1' and p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' $where_str order by pd.products_name asc");

        if (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SEARCH_IN_DESCRIPTION == 'true' && MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHOW_DESCRIPTION != 'none') {
          $short_description_len = (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHORT_DESCRIPTION_LENGTH >= 0 ? MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHORT_DESCRIPTION_LENGTH : 0);
          $start_description_offset = (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHORT_DESCRIPTION_OFFSET >= 0 ? MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHORT_DESCRIPTION_OFFSET : 0);
        }

        $image_size = (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_IMAGE_SIZE > 0 ? MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_IMAGE_SIZE : '50');

        if (tep_db_num_rows($results_query)) {
          while ($results = tep_db_fetch_array($results_query)) {

            if($results['status'] == 1 ) {
              $results_array['price'] = '<span style="color: #575757; font-size: 13px;"><del>' . $currencies->display_price( $results['products_price'], tep_get_tax_rate( $results['products_tax_class_id'] ) ) . '</del>';
              $results_array['price'] .= '<span style="color: #DA2C0D; font-size: 13px;"> ' . $currencies->display_price( $results['specials_new_products_price'], tep_get_tax_rate( $results['products_tax_class_id'] ) ) . '</span></span>';
            } else {
              $results_array['price'] = '<span style="font-size: 13px;">' . $currencies->display_price( $results['products_price'], tep_get_tax_rate( $results['products_tax_class_id'] ) ) . '</span>';
            }

            if (tep_not_null($results['products_image'])) {
              $results_array['img'] = tep_image('images/' . $results['products_image'], NULL, $image_size, 'auto', '', false);
            } else {
              $results_array['img'] = (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_DISPLAY_NO_IMAGE_ICON == 'true' ? tep_image('images/no_img.png', NULL, $image_size, 'auto', '', false) : '');
            }

            if (tep_not_null($results['products_model'])) {
              $results_array['model'] = $results['products_model'];
            } else {
              $results_array['model'] = '';
            }

            if (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_INCLUDE_MANUFACTURER == 'true') {
              $results_array['manufacturer'] = (tep_not_null($results['manufacturers_name']) ? $results['manufacturers_name'] : '');
            } else {
              $results_array['manufacturer'] = '';
            }

            if (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SEARCH_IN_DESCRIPTION == 'true' && MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHOW_DESCRIPTION != 'none') {
              if (tep_not_null($results['products_description'])) {

                // ----- remove HTML TAGs -----
                $description_text = preg_replace('/<[^>]*>/', ' ', $results['products_description']);
                $description_text = str_replace("\n", ' ', $description_text);
                $description_text = str_replace("\r", ' ', $description_text);
                $description_text = str_replace("\t", ' ', $description_text);
                // ----- remove multiple spaces -----
                $description_text = trim(preg_replace('/ {2,}/', ' ', $description_text));

                if (MODULE_HEADER_TAGS_TWITTER_TYPEAHEAD_SHOW_DESCRIPTION == 'part') {

                  $description_len = strlen($description_text);

                  if ($description_len > $short_description_len) {

                    // Each description is tested to find the first matching keyword in the description, starting with the first keyword (when there are multiple keywords).
                    // If the first keyword isn't found in the description it will keep looping below to try to find the next keyword's first match, and so on until a first match is found.
                    // This first match for each description is where the shortened description starts, but can be offset to the left using the "Short Description Offset" setting in admin (unless it's already near start or end of description).
                    // If keyword highlighting is enabled, any matching keyword found in the description will still be highlighted in the drop down list.
                    // Thus, the below code is used only to extract part of the description starting with a first matching keyword.
                    $found_first_match = false;

                    reset($term); // $term can contain multiple keywords
                    for ($i=0, $n=sizeof($term); $i<$n; $i++ ) {

                      switch ($term[$i]) {
                        case '(':
                        case ')':
                        case 'and':
                        case 'or':
                          break;
                        default:
                          $keyword = tep_db_prepare_input($term[$i]);

                          $match_pos = stripos($description_text, $keyword);
                          if ($match_pos !== false) {
                            $start_description = ($match_pos-$start_description_offset > 0 ? $match_pos-$start_description_offset : 0);
                            $remain_chars = $description_len - ($start_description+$short_description_len);

                            $results_array['description'] = ($start_description > 0 ? '...' : '') . trim(($start_description+round(strlen($keyword)/2) < $description_len/2 ? substr($description_text, ($start_description > 0 ? $start_description : 0), $short_description_len) : ($remain_chars > 0 ? substr($description_text, $start_description, $short_description_len) : substr($description_text, -$short_description_len)))) . ($remain_chars > 0 ? '...' : '');
                            $found_first_match = true;
                          }
                          break;
                      }
                      if ($found_first_match) break;
                    }
                    if ($found_first_match == false) {
                      $results_array['description'] = substr($description_text, 0, $short_description_len) . '...';
                    }
                  } else {
                    $results_array['description'] = $description_text;
                  }
                } else {
                  $results_array['description'] = $description_text;
                }
              } else {
                $results_array['description'] = '';
              }
            } else {
              $results_array['description'] = '';
            }

            $results_array['name'] = $results['products_name'];
            $results_array['link'] = tep_href_link('product_info.php', 'products_id=' . $results['products_id']);
            $results_array['pid'] = $results['products_id'];
            array_push($return_array, $results_array);

          }

          print json_encode($return_array);
        }

      }

    }
  }

}

require('includes/application_bottom.php');

?>
